﻿Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Public Class Form1
    Dim device As Direct3D.Device
    Dim aspectratio As Single = 1
    Dim CameraDegrees As Integer = 0

    Dim MyTriangleStrip(3) As CustomVertex.PositionColored
    Dim MyTriangleFan(9) As CustomVertex.PositionColored
    Dim MyLineList(9) As CustomVertex.PositionColored



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MyTriangleStrip(0) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, 10, 0, Color.Blue.ToArgb)
        MyTriangleStrip(1) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, 10, 0, Color.Red.ToArgb)
        MyTriangleStrip(2) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, -10, 0, Color.Green.ToArgb)
        MyTriangleStrip(3) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, -10, 0, Color.Yellow.ToArgb)

        MyTriangleFan(0) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, 0, 0, Color.Blue.ToArgb)
        MyTriangleFan(1) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, 3, 0, Color.Red.ToArgb)
        MyTriangleFan(2) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, 10, 0, Color.Green.ToArgb)
        MyTriangleFan(3) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-3, 0, 0, Color.Red.ToArgb)
        MyTriangleFan(4) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, -10, 0, Color.Green.ToArgb)
        MyTriangleFan(5) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, -3, 0, Color.Red.ToArgb)
        MyTriangleFan(6) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, -10, 0, Color.Green.ToArgb)
        MyTriangleFan(7) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(3, 0, 0, Color.Red.ToArgb)
        MyTriangleFan(8) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, 10, 0, Color.Green.ToArgb)
        MyTriangleFan(9) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, 3, 0, Color.Red.ToArgb)

        MyLineList(0) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, 0, 0, Color.White.ToArgb)
        MyLineList(1) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(0, 0, 10, Color.Blue.ToArgb)
        MyLineList(2) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, 10, 0, Color.Purple.ToArgb)
        MyLineList(3) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, 10, 5, Color.Purple.ToArgb)
        MyLineList(4) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, -10, 0, Color.Tan.ToArgb)
        MyLineList(5) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(-10, -10, 5, Color.Tan.ToArgb)
        MyLineList(6) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, -10, 0, Color.Red.ToArgb)
        MyLineList(7) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, -10, 5, Color.Red.ToArgb)
        MyLineList(8) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, 10, 0, Color.Orange.ToArgb)
        MyLineList(9) = New Microsoft.DirectX.Direct3D.CustomVertex.PositionColored(10, 10, 5, Color.Orange.ToArgb)




        InitializeDXGraphics()
        Timer1.Start()
    End Sub

    Private Sub Form1_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        aspectratio = Me.Width / Me.Height
    End Sub

    Public Sub InitializeDXGraphics()
        Try
            aspectratio = Me.Width / Me.Height

            Dim present As PresentParameters = New PresentParameters
            present.Windowed = True 'draw on a window
            present.SwapEffect = SwapEffect.Discard 'discuss later

            Dim DevCaps As Direct3D.Caps = Direct3D.Manager.GetDeviceCaps(0, DeviceType.Hardware)
            
            If (DevCaps.DeviceCaps.SupportsHardwareTransformAndLight) Then
                device = New Direct3D.Device(0, DeviceType.Hardware, Me, CreateFlags.HardwareVertexProcessing Or CreateFlags.FpuPreserve, present)
            Else
                device = New Direct3D.Device(0, DeviceType.Hardware, Me, CreateFlags.SoftwareVertexProcessing Or CreateFlags.FpuPreserve, present)
            End If
        Catch ex As Exception
            MsgBox("DirectX Initialization Error:" & vbCrLf & ex.Message)
        End Try
    End Sub


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        RedrawGraphics()
        CameraDegrees = (CameraDegrees + 1) Mod 360 'Increment angle for next time
    End Sub


    Public Sub RedrawGraphics()
        Dim CameraDistance As Integer = 30
        Dim CameraX As Single = Math.Sin((CameraDegrees / 180) * Math.PI) * CameraDistance
        Dim CameraY As Single = Math.Cos((CameraDegrees / 180) * Math.PI) * CameraDistance
        Dim dsads As Single = 0

        device.RenderState.Lighting = False
        device.Clear(ClearFlags.Target, Color.Black, 1.0, 0)
        device.BeginScene()
        'device.RenderState.CullMode = Cull.None

        device.Transform.View = Matrix.LookAtLH(New Vector3(CameraX, CameraY, 12), New Vector3(0, 0, 0), New Vector3(0, 0, 1))
        'device.Transform.View = Matrix.LookAtLH(New Vector3(0, -1, 30), New Vector3(0, 0, 0), New Vector3(0, 0, 1))
        device.Transform.Projection = Matrix.PerspectiveFovLH(CSng(Math.PI) / 4, aspectratio, 1.0F, 100)

        device.SetTexture(0, Nothing)
        device.VertexFormat = Direct3D.CustomVertex.PositionColored.Format

        device.RenderState.AlphaBlendEnable = True
        device.RenderState.SourceBlend = Blend.SourceAlpha
        device.RenderState.DestinationBlend = Blend.InvSourceAlpha
        device.VertexFormat = CustomVertex.PositionColored.Format


        device.DrawUserPrimitives(PrimitiveType.TriangleStrip, 2, MyTriangleStrip)
        'device.DrawUserPrimitives(PrimitiveType.TriangleFan, 8, MyTriangleFan)
        'device.DrawUserPrimitives(PrimitiveType.LineList, 5, MyLineList)

        device.EndScene()
        device.Present()
    End Sub
    
   
   
End Class
